require 'node'

webserviceX = {}


local Url = 'http://www.webservicex.net/'
local SoapAction = 'http://www.webserviceX.NET/'

-- The soap request that calls the convert temperature web service
D = [[<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" 
                        xmlns:web="http://www.webserviceX.NET/">
   <soapenv:Header/>
   <soapenv:Body>
      <web:ConvertTemp>
         <web:Temperature>?</web:Temperature>
         <web:FromUnit>?</web:FromUnit>
         <web:ToUnit>?</web:ToUnit>
      </web:ConvertTemp>
   </soapenv:Body>
</soapenv:Envelope>
]]

local function trace(a,b,c,d) return end

function GetHL7Message(HL7)
   -- Let's begin by brininging in some sample data
   local Orig = hl7.parse{vmd='HL7_2.5.1.vmd',data=HL7}
   local Out = hl7.message{vmd='HL7_2.5.1.vmd',name=Orig:nodeName()}   
   Out:mapTree(Orig)
   return Out
end

function MakeRequest(HL7, TempFrom, TempTo)
   
   local P = xml.parse{data=D}
   
   P["soapenv:Envelope"]["soapenv:Body"]
   ["web:ConvertTemp"]["web:Temperature"][1]=
   HL7.PATIENT_RESULT[1].ORDER_OBSERVATION[1].OBSERVATION[2].OBX[5][1]
 
   P["soapenv:Envelope"]["soapenv:Body"]
   ["web:ConvertTemp"]["web:FromUnit"][1]=TempFrom
   
   P["soapenv:Envelope"]["soapenv:Body"]
   ["web:ConvertTemp"]["web:ToUnit"][1]=TempTo
   
   return P
end


function webserviceX.ConvertTemp(HL7,TempFrom, TempTo)
   
   local Msg = GetHL7Message(HL7)
   local P = MakeRequest(Msg, TempFrom, TempTo)
   
    
   -- Call the convert temperature web service 
   -- and save the result to a local variable  
   local R,C,D = net.http.post{url=Url.. 'ConvertTemperature.asmx', 
      headers={['Content-type']='text/xml;charset=UTF-8', 
         SOAPAction=SoapAction.. 'ConvertTemp'}, 
      body=P:S(),
      live=true}
   
   trace(C,D,R)
   
   -- Create variable "X" that points to our parsed soap response and 
   -- populate our outbound message with the converted temperature
   -- and units of measure
   return xml.parse{data=R} 
   
end

-- Returns nil if we do not have a SOAP fault response
function webserviceX.IsFault(X)
   return X["soap:Envelope"]["soap:Body"]["soap:Fault"]   
end

-- Extracts the response message from a non fault response
function GetResponse(X)
   return X["soap:Envelope"]["soap:Body"].
    ConvertTempResponse.ConvertTempResult[1]
end

-- Extracts the error message from a fault response
function webserviceX.GetFault(X)
   return X["soap:Envelope"]["soap:Body"]
           ["soap:Fault"].faultstring[1]:S()
end

-- Create a message that will be sent to the destination endpoint
function webserviceX.CreateOutMsg(HL7, X, TempTo)
   local Out = GetHL7Message(HL7)
   
   local TempValue
   
   if TempTo == TempC then
      TempValue = DegreesC
   else
      TempValue = DegreesF     
   end
   
   Out.PATIENT_RESULT[1].ORDER_OBSERVATION[1].OBSERVATION[2].OBX[5][1]=GetResponse(X)
   Out.PATIENT_RESULT[1].ORDER_OBSERVATION[1].OBSERVATION[2].OBX[6][2]=TempValue
  
   return Out
end
